from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, File, String

Joinkunitigs_V3_V0_1_0 = CommandToolBuilder(tool="joinKUnitigs_v3", base_command=["joinKUnitigs_v3"], inputs=[ToolInput(tag="in_min_overlap_length", input_type=Int(optional=True), prefix="--min-overlap-length", doc=InputDocumentation(doc="*Minimum length of an overlap between unitigs")), ToolInput(tag="in_mean_and_stdev_by_prefix_file", input_type=File(optional=True), prefix="--mean-and-stdev-by-prefix-file", doc=InputDocumentation(doc="*File containing the mean and stdev for each prefix library.")), ToolInput(tag="in_num_stdev_s_allowed", input_type=Int(optional=True), prefix="--num-stdevs-allowed", doc=InputDocumentation(doc="Number of standard deviations the join length can be from the mean when trying to join a mate pair. (5)")), ToolInput(tag="in_unit_ig_lengths_file", input_type=File(optional=True), prefix="--unitig-lengths-file", doc=InputDocumentation(doc="*File containing the length of the unitigs.")), ToolInput(tag="in_k_unit_igs_translation_file", input_type=File(optional=True), prefix="--kunitigs-translation-file", doc=InputDocumentation(doc="File containing map from original unitigs to new (longer) unitigs.")), ToolInput(tag="in_overlaps_file", input_type=File(optional=True), prefix="--overlaps-file", doc=InputDocumentation(doc="*Celera-style overlap file between unitigs in binary format.")), ToolInput(tag="in_num_k_unit_igs_file", input_type=File(optional=True), prefix="--num-kunitigs-file", doc=InputDocumentation(doc="*File containing the number of k-unitigs.")), ToolInput(tag="in_max_nodes_allowed", input_type=Int(optional=True), prefix="--max-nodes-allowed", doc=InputDocumentation(doc="Max records allowed when trying to join a mate pair. (4000)")), ToolInput(tag="in_join_aggressive", input_type=Int(optional=True), prefix="--join-aggressive", doc=InputDocumentation(doc="Report a join even if it is not unique. (0)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="Output file (super_reads_output)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads (1)")), ToolInput(tag="in_cmdline_parse", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_input_file", input_type=File(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="Output file (super_reads_output)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Joinkunitigs_V3_V0_1_0().translate("wdl", allow_empty_container=True)

